"""
My first application
"""
import toga
# from toga.style import Pack
from toga.style.pack import COLUMN, ROW, Pack, LEFT, RIGHT


class HelloWorld(toga.App):
    def startup(self):
        c_box = toga.Box()
        f_box = toga.Box()
        box = toga.Box()

        self.c_input = toga.TextInput(readonly=True)
        self.f_input = toga.TextInput()

        c_label = toga.Label("Celcius", style=Pack(text_align=LEFT))
        f_label = toga.Label("Farenheit", style=Pack(text_align=LEFT))
        join_label = toga.Label("is equivalent to",
                                style=Pack(text_align=RIGHT))

        button = toga.Button("Calculate", on_press=self.calculate)

        f_box.add(self.f_input)
        f_box.add(f_label)

        c_box.add(join_label)
        c_box.add(self.c_input)
        c_box.add(c_label)

        box.add(f_box)
        box.add(c_box)
        box.add(button)

        box.style.update(direction=COLUMN, padding=10)
        f_box.style.update(direction=ROW, padding=5)
        c_box.style.update(direction=ROW, padding=5)

        self.c_input.style.update(flex=1)
        self.f_input.style.update(flex=1, padding_left=210)
        c_label.style.update(width=100, padding_left=10)
        f_label.style.update(width=100, padding_left=10)
        join_label.style.update(width=200, padding_left=10)

        button.style.update(padding=15)

        self.main_window = toga.MainWindow(title=self.formal_name)
        self.main_window.content = box
        self.main_window.show()

    def calculate(self, widget):
        try:
            self.c_input.value = (float(self.f_input.value) - 32.0) * 5.0 / 9.0
        except:
            self.c_input.value = "???"

    def quit(self, widget):
        if self.on_exit is not None:
            self.on_exit()
        self.exit()

    def say_hello(self, widget):
        self.main_window.info_dialog(
                f"Hello, {self.name_input.value}",
                "sup dawg!"
                )


def main():
    return HelloWorld()
